-- name: [CS] Annalynn
-- description: Write blurb/description here!\n\n\\#ff7777\\This Pack requires Character Select\nto use as a Library!

--[[
    API Documentation for Character Select can be found below:
    https://github.com/Squishy6094/character-select-coop/wiki/API-Documentation

    Use this if you're curious on how anything here works >v<
	(This is an edited version of the Template File by Squishy)
]]

local TEXT_MOD_NAME = "Annalynn"

-- Stops mod from loading if Character Select isn't on
if not _G.charSelectExists then
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
    return 0
end

local E_MODEL_ANNA = smlua_model_util_get_id("anna_geo") -- Located in "actors"

local ANNA_OFFSET = 0

local TEX_ANNA_ICON = get_texture_info("anna_icon") -- Located in "textures"

-- All Located in "sound" Name them whatever you want. Remember to include the .ogg extension
local VOICETABLE_ANNA = {
    [CHAR_SOUND_OKEY_DOKEY] = {'letsgetdigging.ogg', 'letsgetdiggingeh.ogg'}, -- Starting game
	[CHAR_SOUND_LETS_A_GO] = {'letsgetdigging.ogg', 'letsgetdiggingeh.ogg'}, -- Starting level
	[CHAR_SOUND_PUNCH_YAH] = 'huh2.ogg', -- Punch 1
	[CHAR_SOUND_PUNCH_WAH] = 'hah.ogg', -- Punch 2
	[CHAR_SOUND_PUNCH_HOO] = 'hyah.ogg', -- Punch 3
	[CHAR_SOUND_YAH_WAH_HOO] = {'hah.ogg', 'huh2.ogg', 'hyah.ogg'}, -- First/Second jump sounds
	[CHAR_SOUND_HOOHOO] = 'huh.ogg', -- Third jump sound
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'timetofly.ogg', 'timetofly2.ogg'}, -- Triple jump sounds
	[CHAR_SOUND_UH] = 'mnh.ogg', -- Wall bonk
	[CHAR_SOUND_UH2] = 'mnh.ogg', -- Landing after long jump
	[CHAR_SOUND_UH2_2] = 'mnh.ogg', -- Same sound as UH2; jumping onto ledge
	[CHAR_SOUND_HAHA] = 'haha.ogg', -- Landing triple jump
	[CHAR_SOUND_YAHOO] = 'heha.ogg', -- Long jump
	[CHAR_SOUND_DOH] = 'ack.ogg', -- Long jump wall bonk
	[CHAR_SOUND_WHOA] = 'woah.ogg', -- Grabbing ledge
	[CHAR_SOUND_EEUH] = 'mph.ogg', -- Climbing over ledge
	[CHAR_SOUND_WAAAOOOW] = 'waahh.ogg', -- Falling a long distance
	[CHAR_SOUND_TWIRL_BOUNCE] = 'chaching.ogg', -- Bouncing off of a flower spring
	[CHAR_SOUND_GROUND_POUND_WAH] = {'pow.ogg', 'pow2.ogg'}, 
	[CHAR_SOUND_HRMM] = {'gotcha.ogg', 'gotcha2.ogg'}, -- Lifting something
	[CHAR_SOUND_HERE_WE_GO] = 'canada.ogg', -- Star get
	[CHAR_SOUND_SO_LONGA_BOWSER] = 'sayonara.ogg', -- Throwing Bowser
--DAMAGE
	[CHAR_SOUND_ATTACKED] = {'oww.ogg', 'yeouch.ogg', 'yeouch2.ogg'}, -- Damaged
	[CHAR_SOUND_PANTING] = 'Silent.ogg', -- Low health
	[CHAR_SOUND_ON_FIRE] = {'owowow.ogg', 'owhohoo.ogg', 'hothot.ogg'}, -- Burned
--SLEEP SOUNDS
	[CHAR_SOUND_IMA_TIRED] = 'Silent.ogg', -- Mario feeling tired
	[CHAR_SOUND_YAWNING] = 'Silent.ogg', -- Mario yawning before he sits down to sleep
	[CHAR_SOUND_SNORING1] = 'Snore.ogg', -- Snore Inhale
	[CHAR_SOUND_SNORING2] = 'Silent.ogg', -- Exhale
	[CHAR_SOUND_SNORING3] = 'Silent.ogg', -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
	[CHAR_SOUND_COUGHING1] = 'Silent.ogg', -- Cough take 1
	[CHAR_SOUND_COUGHING2] = 'Silent.ogg', -- Cough take 2
	[CHAR_SOUND_COUGHING3] = 'Silent.ogg', -- Cough take 3
--DEATH
	[CHAR_SOUND_DYING] = 'ack.ogg', -- Dying from damage
	[CHAR_SOUND_DROWNING] = {'drown.ogg', 'drown2.ogg'}, -- Running out of air underwater
	[CHAR_SOUND_MAMA_MIA] = 'payday.ogg' -- Booted out of level
}

-- All Located in "actors"
local CAPTABLE_ANNA = {
    normal = smlua_model_util_get_id("annacap_geo"),
    wing = smlua_model_util_get_id("annawing_geo"),
    metal = smlua_model_util_get_id("annametalcap_geo"),
	metalWing = smlua_model_util_get_id("annametalwingcap_geo")
}

local PALETTE_ANNA = {
    [PANTS]  = "3C2FFF",
    [SHIRT]  = "5AA6FF",
    [GLOVES] = "ffffff",
    [SHOES]  = "5AA6FF",
    [HAIR]   = "762F00",
    [SKIN]   = "FFC6A8",
    [CAP]    = "5AA6FF",
	[EMBLEM] = "ffffff"
}

local PALETTE_ANNA2 = {
    [PANTS]  = "DE0000",
    [SHIRT]  = "FF9700",
    [GLOVES] = "ffffff",
    [SHOES]  = "FF9700",
    [HAIR]   = "762F00",
    [SKIN]   = "FFC6A8",
    [CAP]    = "FF9700",
	[EMBLEM] = "ffffff"
}

local PALETTE_ANNA3 = {
    [PANTS]  = "DE0047",
    [SHIRT]  = "6897FF",
    [GLOVES] = "ffffff",
    [SHOES]  = "6897FF",
    [HAIR]   = "762F00",
    [SKIN]   = "FFC6A8",
    [CAP]    = "6897FF",
	[EMBLEM] = "ffffff"
}

local PALETTE_ANNA4 = {
    [PANTS]  = "B80097",
    [SHIRT]  = "FF6897",
    [GLOVES] = "ffffff",
    [SHOES]  = "FF6897",
    [HAIR]   = "762F00",
    [SKIN]   = "FFC6A8",
    [CAP]    = "FF6897",
	[EMBLEM] = "ffffff"
}

local PALETTE_ANNA5 = {
    [PANTS]  = "216847",
    [SHIRT]  = "68DE00",
    [GLOVES] = "ffffff",
    [SHOES]  = "68DE00",
    [HAIR]   = "762F00",
    [SKIN]   = "FFC6A8",
    [CAP]    = "68DE00",
	[EMBLEM] = "ffffff"
}

local PALETTE_ANNA6 = {
    [PANTS]  = "684700",
    [SHIRT]  = "47B800",
    [GLOVES] = "ffffff",
    [SHOES]  = "47B800",
    [HAIR]   = "762F00",
    [SKIN]   = "FFC6A8",
    [CAP]    = "47B800",
	[EMBLEM] = "ffffff"
}

local PALETTE_ANNA7 = {
    [PANTS]  = "472197",
    [SHIRT]  = "DE0097",
    [GLOVES] = "ffffff",
    [SHOES]  = "DE0097",
    [HAIR]   = "762F00",
    [SKIN]   = "FFC6A8",
    [CAP]    = "DE0097",
	[EMBLEM] = "ffffff"
}

local PALETTE_ANNA8 = {
    [PANTS]  = "474747",
    [SHIRT]  = "FF0047",
    [GLOVES] = "ffffff",
    [SHOES]  = "FF0047",
    [HAIR]   = "762F00",
    [SKIN]   = "FFC6A8",
    [CAP]    = "FF0047",
	[EMBLEM] = "ffffff"
}


local PALETTE_ANNA9 = {
    [PANTS]  = "970097",
    [SHIRT]  = "FF6800",
    [GLOVES] = "ffffff",
    [SHOES]  = "FF6800",
    [HAIR]   = "762F00",
    [SKIN]   = "FFC6A8",
    [CAP]    = "FF6800",
	[EMBLEM] = "ffffff"
}

local PALETTE_ANNA10 = {
    [PANTS]  = "970047",
    [SHIRT]  = "FF0000",
    [GLOVES] = "ffffff",
    [SHOES]  = "FF0000",
    [HAIR]   = "762F00",
    [SKIN]   = "FFC6A8",
    [CAP]    = "FF0000",
	[EMBLEM] = "ffffff"
}

local PALETTE_ANNA11 = {
    [PANTS]  = "B80047",
    [SHIRT]  = "FF6847",
    [GLOVES] = "ffffff",
    [SHOES]  = "FF6847",
    [HAIR]   = "762F00",
    [SKIN]   = "FFC6A8",
    [CAP]    = "FF6847",
	[EMBLEM] = "ffffff"
}

local PALETTE_ANNA12 = {
    [PANTS]  = "689797",
    [SHIRT]  = "DEFFFF",
    [GLOVES] = "ffffff",
    [SHOES]  = "DEFFFF",
    [HAIR]   = "762F00",
    [SKIN]   = "FFC6A8",
    [CAP]    = "DEFFFF",
	[EMBLEM] = "ffffff"
}

local PALETTE_ANNA13 = {
    [PANTS]  = "6847FF",
    [SHIRT]  = "B8B8FF",
    [GLOVES] = "ffffff",
    [SHOES]  = "B8B8FF",
    [HAIR]   = "762F00",
    [SKIN]   = "FFC6A8",
    [CAP]    = "B8B8FF",
	[EMBLEM] = "ffffff"
}

local PALETTE_ANNA14 = {
    [PANTS]  = "009797",
    [SHIRT]  = "00FF97",
    [GLOVES] = "ffffff",
    [SHOES]  = "00FF97",
    [HAIR]   = "762F00",
    [SKIN]   = "FFC6A8",
    [CAP]    = "00FF97",
	[EMBLEM] = "ffffff"
}

local PALETTE_ANNA15 = {
    [PANTS]  = "472147",
    [SHIRT]  = "2147FF",
    [GLOVES] = "ffffff",
    [SHOES]  = "2147FF",
    [HAIR]   = "762F00",
    [SKIN]   = "FFC6A8",
    [CAP]    = "2147FF",
	[EMBLEM] = "ffffff"
}

local PALETTE_ANNA16 = {
    [PANTS]  = "686847",
    [SHIRT]  = "97B847",
    [GLOVES] = "ffffff",
    [SHOES]  = "97B847",
    [HAIR]   = "762F00",
    [SKIN]   = "FFC6A8",
    [CAP]    = "97B847",
	[EMBLEM] = "ffffff"
}

local PALETTE_ANNA17 = {
    [PANTS]  = "470097",
    [SHIRT]  = "B800FF",
    [GLOVES] = "ffffff",
    [SHOES]  = "B800FF",
    [HAIR]   = "762F00",
    [SKIN]   = "FFC6A8",
    [CAP]    = "B800FF",
	[EMBLEM] = "ffffff"
}

local PALETTE_ANNA18 = {
    [PANTS]  = "474797",
    [SHIRT]  = "979797",
    [GLOVES] = "ffffff",
    [SHOES]  = "979797",
    [HAIR]   = "762F00",
    [SKIN]   = "FFC6A8",
    [CAP]    = "979797",
	[EMBLEM] = "ffffff"
}

local PALETTE_ANNA19 = {
    [PANTS]  = "682100",
    [SHIRT]  = "B8FF47",
    [GLOVES] = "ffffff",
    [SHOES]  = "B8FF47",
    [HAIR]   = "762F00",
    [SKIN]   = "FFC6A8",
    [CAP]    = "B8FF47",
	[EMBLEM] = "ffffff"
}

local PALETTE_ANNA20 = {
    [PANTS]  = "216897",
    [SHIRT]  = "47B897",
    [GLOVES] = "ffffff",
    [SHOES]  = "47B897",
    [HAIR]   = "762F00",
    [SKIN]   = "FFC6A8",
    [CAP]    = "47B897",
	[EMBLEM] = "ffffff"
}

local PALETTE_ANNA21 = {
    [PANTS]  = "474797",
    [SHIRT]  = "9768FF",
    [GLOVES] = "ffffff",
    [SHOES]  = "9768FF",
    [HAIR]   = "762F00",
    [SKIN]   = "FFC6A8",
    [CAP]    = "9768FF",
	[EMBLEM] = "ffffff"
}

local PALETTE_ANNA22 = {
    [PANTS]  = "474747",
    [SHIRT]  = "FFB800",
    [GLOVES] = "ffffff",
    [SHOES]  = "FFB800",
    [HAIR]   = "762F00",
    [SKIN]   = "FFC6A8",
    [CAP]    = "FFB800",
	[EMBLEM] = "ffffff"
}

local PALETTE_ANNA23 = {
    [PANTS]  = "B86847",
    [SHIRT]  = "FFB847",
    [GLOVES] = "ffffff",
    [SHOES]  = "FFB847",
    [HAIR]   = "762F00",
    [SKIN]   = "FFC6A8",
    [CAP]    = "FFB847",
	[EMBLEM] = "ffffff"
}

local PALETTE_ANNA24 = {
    [PANTS]  = "371697",
    [SHIRT]  = "856ED7",
    [GLOVES] = "ffffff",
    [SHOES]  = "856ED7",
    [HAIR]   = "413442",
    [SKIN]   = "D9BBD9",
    [CAP]    = "856ED7",
	[EMBLEM] = "ffffff"
}

local HM_ANNA= {
    label = {
        left = get_texture_info("anna_leftHealth"),
        right = get_texture_info("anna_rightHealth"),
    },
    pie = {
        [1] = get_texture_info("Pie1"),
        [2] = get_texture_info("Pie2"),
        [3] = get_texture_info("Pie3"),
        [4] = get_texture_info("Pie4"),
        [5] = get_texture_info("Pie5"),
        [6] = get_texture_info("Pie6"),
        [7] = get_texture_info("Pie7"),
        [8] = get_texture_info("Pie8"),
    }
}

local CSloaded = false
local function on_character_select_load()
    CT_ANNA = _G.charSelect.character_add("Annalynn", {"The Canadian Woman of All Time", "Annalynn Midway brings her high spirits to", "the Mushroom Kingdom to help Mario", "and his friends bring peace to Peach's Castle!", "(She's mostly here for the cake, though.)"}, "Mod/Model: Zepiereite/ Character: Cruise Elroy/ VA: Elspeth Eastman", {r = 92, g = 190, b = 255},  E_MODEL_ANNA, CT_MARIO, TEX_ANNA_ICON, 1.0, ANNA_OFFSET)
    _G.charSelect.character_add_caps(E_MODEL_ANNA, CAPTABLE_ANNA)
    _G.charSelect.character_add_voice(E_MODEL_ANNA, VOICETABLE_ANNA)
 --   _G.charSelect.character_add_celebration_star(E_MODEL_ANNA, E_MODEL_ANNA, TEX_CUSTOM_STAR_ANNA)
    _G.charSelect.character_add_palette_preset(E_MODEL_ANNA, PALETTE_ANNA)
	_G.charSelect.character_add_palette_preset(E_MODEL_ANNA, PALETTE_ANNA2)
	_G.charSelect.character_add_palette_preset(E_MODEL_ANNA, PALETTE_ANNA3)
	_G.charSelect.character_add_palette_preset(E_MODEL_ANNA, PALETTE_ANNA4)
	_G.charSelect.character_add_palette_preset(E_MODEL_ANNA, PALETTE_ANNA5)
	_G.charSelect.character_add_palette_preset(E_MODEL_ANNA, PALETTE_ANNA6)
	_G.charSelect.character_add_palette_preset(E_MODEL_ANNA, PALETTE_ANNA7)
	_G.charSelect.character_add_palette_preset(E_MODEL_ANNA, PALETTE_ANNA8)
	_G.charSelect.character_add_palette_preset(E_MODEL_ANNA, PALETTE_ANNA9)
	_G.charSelect.character_add_palette_preset(E_MODEL_ANNA, PALETTE_ANNA10)
	_G.charSelect.character_add_palette_preset(E_MODEL_ANNA, PALETTE_ANNA11)
	_G.charSelect.character_add_palette_preset(E_MODEL_ANNA, PALETTE_ANNA12)
	_G.charSelect.character_add_palette_preset(E_MODEL_ANNA, PALETTE_ANNA13)
	_G.charSelect.character_add_palette_preset(E_MODEL_ANNA, PALETTE_ANNA14)
	_G.charSelect.character_add_palette_preset(E_MODEL_ANNA, PALETTE_ANNA15)
	_G.charSelect.character_add_palette_preset(E_MODEL_ANNA, PALETTE_ANNA16)
	_G.charSelect.character_add_palette_preset(E_MODEL_ANNA, PALETTE_ANNA17)
	_G.charSelect.character_add_palette_preset(E_MODEL_ANNA, PALETTE_ANNA18)
	_G.charSelect.character_add_palette_preset(E_MODEL_ANNA, PALETTE_ANNA19)
	_G.charSelect.character_add_palette_preset(E_MODEL_ANNA, PALETTE_ANNA20)
	_G.charSelect.character_add_palette_preset(E_MODEL_ANNA, PALETTE_ANNA21)
	_G.charSelect.character_add_palette_preset(E_MODEL_ANNA, PALETTE_ANNA22)
	_G.charSelect.character_add_palette_preset(E_MODEL_ANNA, PALETTE_ANNA23)
	_G.charSelect.character_add_palette_preset(E_MODEL_ANNA, PALETTE_ANNA24)
	
    _G.charSelect.character_add_health_meter(CT_ANNA, HM_ANNA)

    CSloaded = true
end

local function on_character_sound(m, sound)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_ANNA then return _G.charSelect.voice.sound(m, sound) end
end

local function on_character_snore(m)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_ANNA then return _G.charSelect.voice.snore(m) end
end

hook_event(HOOK_ON_MODS_LOADED, on_character_select_load)
hook_event(HOOK_CHARACTER_SOUND, on_character_sound)
hook_event(HOOK_MARIO_UPDATE, on_character_snore)